<?php

namespace RxConnexionBundle\Repository;

class AccountRepository extends \Doctrine\ORM\EntityRepository
{
    public function validate($account_form) {

        $errors = array();

        $action = $account_form['action'];

        // d = delete
        if($action !== 'd') {

            $accountExist = $this->getEntityManager()->getRepository('RxConnexionBundle:AccountEntity')
                ->createQueryBuilder('a')
                ->where('a.id != :id')
                ->andWhere('a.isDeleted != :isDeleted')
                ->andWhere('a.description = :description')
                ->setParameters(array(
                    'id' => $account_form['id'],
                    'isDeleted' => 1,
                    'description' => $account_form['description']
                ))
                ->getQuery()->getResult();

            if($accountExist)
                $errors[] = 'Description already exist.';
        }

        return $errors;
    }
    public function ajax_list(array $get){

        $columns = array(
            array('a.`id`', "a.`id`"),
            array('a.`code`', 'a.`code`'),
            array('a.`description`', 'a.`description`'),
            array('a.`e_mail`', 'a.`e_mail`'),
            array('a.`mobile_no`', 'a.`mobile_no`'),
            array('a.`phone_no`', 'a.`phone_no`')
        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `account` a";
        $joins = "";
        $sqlWhere = "WHERE a.`is_deleted` = 0";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

        /*
         * Filtering
         */
        if(isset($get['search']) && $get['search']['value'] != ''){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
            }
        }

        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($stmtParams);
        $result_count = $query->fetchAll();

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($stmtParams);
        $result = $query->fetchAll();

        return array(
            'results' => $result,
            'total' => count($result_count)
        );
    }
    
    public function autocomplete_suggestions($q) {

        $sql = "
            SELECT
                c.`id`,
                c.`description` AS data,
                c.`description` AS value
            FROM `account` c
            WHERE c.`description` LIKE :description
            AND c.`is_deleted` = 0 OR c.`is_deleted` IS NULL
            ORDER BY c.`description`
            LIMIT 0,20
        ";

        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        $query->execute(array(
            'description' => "%$q%"
        ));

        $result = $query->fetchAll();

        return $result;
    }
    
}
